
local sui, cfg, suf, smu, cpf = SkyUI, SkyUI.Config, SkyUI.Config.UnitFrames, SkyUI.Modules.UnitFrames, ColorPickerFrame
local _SavePending, _Save, evt = false, {}, nil

local function round(num, idp) return tonumber(string.format("%." .. (idp or 0) .. "f", num)) end

local mnuitems = {}

local function SaveValues(c)
 if c then _Save[c.name] = true end
 if InCombatLockdown() then _SavePending = true return true end

 if _Save["cHud"] then if mnuitems.cHud:GetChecked() then smu.Disable() else smu.Enable() end end
-- if _Save["cActionBars"] then if mnuitems.cActionBars:GetChecked() then SkyUI.Modules.ActionBars.Disable() else SkyUI.Modules.ActionBars.Enable() end end
 
 if _Save["cFocus"] then suf.focus.Enabled = mnuitems.cFocus:GetChecked() end
 if _Save["cPet"] then suf.playerpet.Enabled = mnuitems.cPet:GetChecked() end
 if _Save["cPetTarget"] then suf.playerpettarget.Enabled = mnuitems.cPetTarget:GetChecked() end
 if _Save["cTargetTarget"] then suf.targettarget.Enabled = mnuitems.cTargetTarget:GetChecked() end
 if _Save["cTargetPet"] then suf.targetpet.Enabled = mnuitems.cTargetPet:GetChecked() end
 if _Save["cTargetPetTarget"] then suf.targetpettarget.Enabled = mnuitems.cTargetPetTarget:GetChecked() end

 if _Save["HudScale"] then suf.UI.Scale = round(mnuitems.HudScale:GetValue()) / 100 end

 if _Save["HorzOffset"] then suf.UI.OffsetX = round(mnuitems.HorzOffset:GetValue()) end
 if _Save["VertOffset"] then suf.UI.OffsetY = round(mnuitems.VertOffset:GetValue()) end


 if _Save["cAuras"] then if mnuitems.cAuras:GetChecked() then smu.Auras.Disable() else smu.Auras.Enable() end end

 if _Save["cSwap"] then suf.Auras.Swap = mnuitems.cSwap:GetChecked() end
 if _Save["cCDBD"] then suf.Auras.CooldownBackdrop = not mnuitems.cCDBD:GetChecked() end

 if _Save["cBuffs"] then suf.Auras.Buffs.Enabled = not mnuitems.cBuffs:GetChecked() end
 if _Save["cBuffBar"] then suf.Auras.Buffs.Bars = mnuitems.cBuffBar:GetChecked() end
 if _Save["cBuffName"] then suf.Auras.Buffs.Names = mnuitems.cBuffName:GetChecked() end
 if _Save["cBuffCD"] then suf.Auras.Buffs.CD = mnuitems.cBuffCD:GetChecked() end

 if _Save["cDebuffs"] then suf.Auras.Debuffs.Enabled = not mnuitems.cDebuffs:GetChecked() end
 if _Save["cDebuffBar"] then suf.Auras.Debuffs.Bars = mnuitems.cDebuffBar:GetChecked() end
 if _Save["cDebuffName"] then suf.Auras.Debuffs.Names = mnuitems.cDebuffName:GetChecked() end
 if _Save["cDebuffCD"] then suf.Auras.Debuffs.CD = mnuitems.cDebuffCD:GetChecked() end
 if _Save["cPlayerDebuffs"] then suf.Auras.Debuffs.PlayerOnly = mnuitems.cPlayerDebuffs:GetChecked() end

 if _Save["MaxBuffBars"] then suf.Auras.Buffs.Max = round(mnuitems.MaxBuffBars:GetValue()) end
 if _Save["MaxBuffBars"] then suf.Auras.Debuffs.Max = round(mnuitems.MaxDebuffBars:GetValue()) end

 if _Save["cRange"] then suf.RangeTransparency = mnuitems.cRange:GetChecked() end

 if _Save["cOOCAlpha"] then suf.UI.player.OOCAlpha = round(mnuitems.cOOCAlpha:GetValue()) / 100 end
 if _Save["cCombatAlpha"] then suf.UI.player.CombatAlpha = round(mnuitems.cCombatAlpha:GetValue()) / 100 end

 if _Save["cInsideAlpha"] then suf.UI.target.InsideAlpha = round(mnuitems.cInsideAlpha:GetValue()) / 100 end
 if _Save["cOutsideAlpha"] then suf.UI.target.OutsideAlpha = round(mnuitems.cOutsideAlpha:GetValue()) / 100 end

 if _Save["cHealthByClass"] then
  if mnuitems.cHealthByClass:GetChecked() then suf.ColorOptions.Health = sui.Structs.By.Class
  else suf.ColorOptions.Health = sui.Structs.By.Default end
 end
 
 
 if _Save["cComboPoints"] then if mnuitems.cComboPoints:GetChecked() then sui.Modules.ComboPoints.Enable() else sui.Modules.ComboPoints.Disable() end end

 if _Save["comboHorzOffset"] then cfg.ComboPoints.UI.OffsetX = round(mnuitems.comboHorzOffset:GetValue()) end
 if _Save["comboVertOffset"] then cfg.ComboPoints.UI.OffsetY = round(mnuitems.comboVertOffset:GetValue()) end

 
 if _Save["cFriendlyHealthColor"] then suf.Clr[mnuitems.cFriendlyHealthColor.cfgVal] = mnuitems.cFriendlyHealthColor.clr end

 sui.Modules.Main:OnConfigUpdated()
 _SavePending = false
 _Save = {}
end


local function PlaceBG(mnu, rf, w, h, name, clr, pad)

 local bg = mnu:CreateTexture("cfg" .. name .. "bg", "BACKGROUND")
 bg:ClearAllPoints()
 bg:SetSize(w, h)
 bg:SetPoint("TOPLEFT", rf, "TOPLEFT", 1 + pad.x, -3 + pad.y)
 bg:SetColorTexture(clr.r, clr.g, clr.b, clr.a)

end

local function PlaceCheckBox(mnu, x, y, rt, name, txt)
 local f = CreateFrame("CheckButton", "cfg" .. name, mnu, "UICheckButtonTemplate")
 mnuitems[name] = f
 f.name = name
 f:ClearAllPoints()

--*TOPLEFT  *TOP  *TOPRIGHT
--LEFT    CENTER   RIGHT
--*BTMLEFT  *BTM  *BTMRIGHT

 if rt == "TOPLEFT" or rt == "TOP" or rt == "TOPRIGHT" then y = -y - 30 elseif rt == "BOTTOMLEFT" or rt == "BOTTOM" or rt == "BOTTOMRIGHT" then  y = y + 55 end
 if rt == "TOPLEFT" or rt == "LEFT" or rt == "BOTTOMLEFT" then x = x + 25 elseif rt == "TOPRIGHT" or rt == "RIGHT" or rt == "BOTTOMRIGHT" then x = x - 25 end
 f:SetPoint(rt, x, y)
 
 f:SetSize(25, 25)
 _G["cfg" .. name .. "Text"]:SetText(" " .. txt)

 local fnt = SkyUI.Strings.Header
 _G["cfg" .. name .. "Text"]:SetFont(fnt.Font, fnt.Size, fnt.Flags)
 _G["cfg" .. name .. "Text"]:SetTextColor(1, 1, 1, 1)
-- _G["cfg" .. name .. "Text"]:SetFontObject(GameFontNormal)
 _G["cfg" .. name .. "Text"]:SetPoint("LEFT", 23, 1)
-- MakeMovable(frame)
 f:SetScript("OnClick", SaveValues)
 
 
-- (point, relativeFrame, relativePoint, ofsx, ofsy);
-- PlaceBG(mnu, f, 200, 18, name, {r = 0.1, g = 0.1, b = 0.1, a = 0}, {x = 0, y = 0})
 
end


local function Slider_ValueChanged(this)
 mnuitems[this._EditBox]:SetText(round(this:GetValue()))
 SaveValues(this)
end


local function EditBox_EnterPressed(this)
 local s = mnuitems[this._Slider]
 local v = tonumber(this:GetText())
 if not v then v = 0 end
 local min, max = s:GetMinMaxValues()
 if v < min then v = min elseif v > max then v = max end
 s:SetValue(v)
 this:SetText(v)
 this:ClearFocus()
end

local function EditBox_MouseWheel(this, delta)
 local s = mnuitems[this._Slider]
 local v = tonumber(this:GetText()) + delta
 if not v then v = 0 end
 local min, max = s:GetMinMaxValues()
 if v < min then v = min elseif v > max then v = max end
 s:SetValue(v)
 this:SetText(v)
end


local function EditBox_FocusLost(this)
 SaveValues(this)
end


local function PlaceText(mnu, x, y, rt, name, txt, slider)
 local f = CreateFrame("EditBox", "cfg" .. name, mnu, "InputBoxTemplate")
 mnuitems[name] = f
 f.name = name

 f:ClearAllPoints()
 
-- if rt == "TOPLEFT" or rt == "TOP" or rt == "TOPRIGHT" then y = -y - 30 elseif rt == "BOTTOMLEFT" or rt == "BOTTOM" or rt == "BOTTOMRIGHT" then  y = y + 50 end
-- if rt == "TOPLEFT" or rt == "LEFT" or rt == "BOTTOMLEFT" then x = x + 20 elseif rt == "TOPRIGHT" or rt == "RIGHT" or rt == "BOTTOMRIGHT" then x = x - 20 end

 f:SetPoint(rt, x, y)
 f:SetParent(mnu)
 
 f:SetSize(40, 22)
 f:SetTextInsets(0,4,7,5)
 f._Slider = slider
 
 f:SetText(txt)

 f:SetFontObject(GameFontHighlight)
 f:SetJustifyH("CENTER")
 
 f:SetMaxLetters(5)
 
 f:SetAutoFocus(false)
 
 f:SetScript("OnEscapePressed", function(this) this:ClearFocus() end)
 f:SetScript("OnEnterPressed", EditBox_EnterPressed)
 f:SetScript("OnMouseWheel", EditBox_MouseWheel)
 f:SetScript("OnEditFocusLost", EditBox_FocusLost)
end



local function PlaceString(mnu, x, y, rt, name, txt, fnt)
 
 local str = mnu:CreateFontString("cfg" .. name)
 
 mnuitems[name] = str
 str.name = name
 str:ClearAllPoints()

 str:SetFont(fnt.Font, fnt.Size, fnt.Flags)
 str:SetPoint(rt, x, y)
 str:SetJustifyH("LEFT")
 str:SetText(txt)
 str:SetTextColor(1, 1, 1, 1)
 --:SetVertexColor(v.Clr.r, v.Clr.g, v.Clr.b, v.Clr.a)
 return str
end


local function PlaceSlider(mnu, x, y, rt, w, name, txt, minVal, maxVal, val, default)

 local f = CreateFrame("Slider", "cfg" .. name, mnu, "OptionsSliderTemplate")

 mnuitems[name] = f
 f.name = name

 if not val then val = default end

 f:ClearAllPoints()
 
 if rt == "TOPLEFT" or rt == "TOP" or rt == "TOPRIGHT" then y = -y - 30 elseif rt == "BOTTOMLEFT" or rt == "BOTTOM" or rt == "BOTTOMRIGHT" then  y = y + 50 end
 if rt == "TOPLEFT" or rt == "LEFT" or rt == "BOTTOMLEFT" then x = x + 20 elseif rt == "TOPRIGHT" or rt == "RIGHT" or rt == "BOTTOMRIGHT" then x = x - 20 end
 f:SetPoint(rt, x, y)

 f:SetSize(w - 60, 15)
 f:SetOrientation("HORIZONTAL")
 
 PlaceText(mnu, x + w - 45, y, rt, name .. "Val", default, name)
 f._EditBox = name .. "Val"
 
 f:SetMinMaxValues(minVal, maxVal);
 f:SetValueStep(1);
 f.DefaultValue = default
 f:SetValue(val)
 f:Show()
 
-- DEFAULT_CHAT_FRAME:AddMessage(["cfg" .. name .. "Low"])
 
 getglobal("cfg" .. name .. "Low"):SetText(minVal)
 getglobal("cfg" .. name .. "High"):SetText(maxVal)
 
 local fnt = SkyUI.Strings.Header
 getglobal("cfg" .. name .. "Text"):SetFont(fnt.Font, fnt.Size, fnt.Flags)
 getglobal("cfg" .. name .. "Text"):SetTextColor(1, 1, 1, 1)
 getglobal("cfg" .. name .. "Text"):SetText(txt)

 
 f:SetScript("OnValueChanged", Slider_ValueChanged)

end

local function PlaceHeader(mnu, x, y, rt, w, name, txt)
 x = x + 8
 if rt == "TOPLEFT" or rt == "TOP" or rt == "TOPRIGHT" then y = -y - 30 elseif rt == "BOTTOMLEFT" or rt == "BOTTOM" or rt == "BOTTOMRIGHT" then  y = y + 50 end
 if rt == "TOPLEFT" or rt == "LEFT" or rt == "BOTTOMLEFT" then x = x + 20 elseif rt == "TOPRIGHT" or rt == "RIGHT" or rt == "BOTTOMRIGHT" then x = x - 20 end
 local str = PlaceString(mnu, x, y, rt, name, txt, SkyUI.Strings.Header)
 
 PlaceBG(mnu, str, w, 20, name, {r = 0.15, g = 0.15, b = .15, a = 1}, {x = -4, y = 7})
end

local function Round(num, idp) return tonumber(string.format("%." .. (idp or 0) .. "f", num)) end

local currentPicker, originalClr = nil, nil
local function changeClr()
 local r, g, b = cpf:GetColorRGB();
 r, g, b = Round(r, 5), Round(g, 5), Round(b, 5)
 currentPicker.clrTexture:SetColorTexture(r, g, b, 1)
 currentPicker.clr.r, currentPicker.clr.g, currentPicker.clr.b, currentPicker.clr.a = r, g, b, 1
 SaveValues(currentPicker)
 SkyUI.player:UpdateUnitReaction()
 SkyUI.target:UpdateUnitReaction()
end

local function opacityClr()
 local r, g, b = cpf:GetColorRGB();
 r, g, b = Round(r, 5), Round(g, 5), Round(b, 5)
 currentPicker.clr.r, currentPicker.clr.g, currentPicker.clr.b, currentPicker.clr.a = r, g, b, 1
 SaveValues(currentPicker)
 SkyUI.player:UpdateUnitReaction()
 SkyUI.target:UpdateUnitReaction()
end

local function cancelClr()
 currentPicker.clrTexture:SetColorTexture(originalClr.r, originalClr.g, originalClr.b, 1)
 currentPicker.clr.r, currentPicker.clr.g, currentPicker.clr.b, currentPicker.clr.a = originalClr.r, originalClr.g, originalClr.b, 1
 SaveValues(currentPicker)
 SkyUI.player:UpdateUnitReaction()
 SkyUI.target:UpdateUnitReaction()
 currentPicker, originalClr = nil, nil
end

local function colorClick(self, bnt)

 cpf.func = changeClr
 cpf.opacityFunc = opacityClr
 cpf.cancelFunc = cancelClr

 currentPicker = self
 originalClr = {r = self.clr.r, g = self.clr.g, b = self.clr.b, a = self.clr.a}
 
 cpf:SetColorRGB(self.clr.r, self.clr.g, self.clr.b);
 cpf:Hide();
 cpf:Show();

end


    
local function PlaceColorPickerBox(mnu, x, y, rt, name, txt, clr, cfgVal)
 x = x + 8

 if rt == "TOPLEFT" or rt == "TOP" or rt == "TOPRIGHT" then y = -y - 30 elseif rt == "BOTTOMLEFT" or rt == "BOTTOM" or rt == "BOTTOMRIGHT" then  y = y + 50 end
 if rt == "TOPLEFT" or rt == "LEFT" or rt == "BOTTOMLEFT" then x = x + 20 elseif rt == "TOPRIGHT" or rt == "RIGHT" or rt == "BOTTOMRIGHT" then x = x - 20 end
 
 local str = PlaceString(mnu, x+20, y-2, "TOPLEFT", "cfg" .. name .. "txt", txt, SkyUI.Strings.Header)

 local f = CreateFrame("Button", "cfg" .. name, mnu)
 f:ClearAllPoints()
 mnuitems[name] = f

 f:RegisterForClicks("AnyUp")
 f:SetScript("OnClick", colorClick)

 f:SetPoint(rt, mnu, "TOPLEFT", x, y)
 f:SetSize(16, 16)

 f.clr = clr
 f.name = name
 f.cfgVal = cfgVal

 local t = f:CreateTexture(nil, "ARTWORK")
 f.clrTexture = t
 
 t:SetAllPoints(f)
 t:SetColorTexture(clr.r, clr.g, clr.b, 1)
 

end


local function OnEventCB(self, evt, ...)
 if evt == "PLAYER_REGEN_ENABLED" then if _SavePending then SaveValues() end
 elseif evt == "PLAYER_REGEN_DISABLED" then SkyUIConfigMenu:Hide() end
end

function ConfigMenu_Loaded()
 if not evt then evt = CreateFrame("Frame")
  SkyUIConfigMenu:HookScript("OnShow",
   function(self)
    self:RegisterEvent("PLAYER_REGEN_DISABLED")
    self:RegisterEvent("PLAYER_REGEN_ENABLED")
    if not InCombatLockdown() and _SavePending then SaveValues() end
   end)
  SkyUIConfigMenu:HookScript("OnHide", function(self) self:UnregisterEvent("PLAYER_REGEN_DISABLED") self:UnregisterEvent("PLAYER_REGEN_ENABLED") end)
  SkyUIConfigMenu:SetScript("OnEvent", OnEventCB)
 end

 local mnu = SkyUIConfigMenu

 -- Tab 1
 PlaceCheckBox(cfgTab1, 0, 10, "TOPLEFT", "cHud", "Disable SkyUI")

 PlaceSlider(cfgTab1, 10, 50, "TOPLEFT", 440, "HudScale", "Hud Scale %", 50, 250, suf.Scale, 100)
 PlaceSlider(cfgTab1, 10, 100, "TOPLEFT", 440, "VertOffset", "Vertical Position", -300, 500, suf.OffsetY, 0)
 PlaceSlider(cfgTab1, 10, 150, "TOPLEFT", 440, "HorzOffset", "Horizontal Position", -400, 50, suf.OffsetX, 0)

-- PlaceText(cfgTab1, 0, 85, "TOP", "HorzOffsetVal", "0", "HorzOffset")
-- PlaceText(cfgTab1, 0, 165, "TOP", "VertOffsetVal", "0", "VertOffset")

 PlaceHeader(cfgTab1, 0, 75, "BOTTOMLEFT", 210, "PlayerFrames", "Player")
 PlaceHeader(cfgTab1, 235, 75, "BOTTOMLEFT", 210, "TargetFrames", "Target")

 PlaceCheckBox(cfgTab1, 0, 40, "BOTTOMLEFT", "cFocus", "Focus")
 PlaceCheckBox(cfgTab1, 0, 20, "BOTTOMLEFT", "cPet", "Pet")
 PlaceCheckBox(cfgTab1, 0, 0, "BOTTOMLEFT", "cPetTarget", "Pet's Target")

 PlaceCheckBox(cfgTab1, 235, 40, "BOTTOMLEFT", "cTargetTarget", "Target")
 PlaceCheckBox(cfgTab1, 235, 20, "BOTTOMLEFT", "cTargetPet", "Pet")
 PlaceCheckBox(cfgTab1, 235, 0, "BOTTOMLEFT", "cTargetPetTarget", "Pet's Target") 
 
 -- Tab 2 (Used to be for actionbars)

 -- Tab 3
 PlaceCheckBox(cfgTab3, 0, 10, "TOPLEFT", "cAuras", "Disable Auras")
 PlaceCheckBox(cfgTab3, 235, 10, "TOPLEFT", "cSwap", "Swap Aura Positions")
 PlaceCheckBox(cfgTab3, 235, 30, "TOPLEFT", "cCDBD", "Disable Cooldown Backdrop")

 PlaceHeader(cfgTab3, 0, 68, "TOPLEFT", 210, "Buffs", "Buffs")
 PlaceHeader(cfgTab3, 235, 68, "TOPLEFT", 210, "Debuffs", "Debuffs")

 PlaceCheckBox(cfgTab3, 0, 100, "TOPLEFT", "cBuffs", "Disable")
 PlaceCheckBox(cfgTab3, 0, 130, "TOPLEFT", "cBuffBar", "Bars")
 PlaceCheckBox(cfgTab3, 0, 150, "TOPLEFT", "cBuffName", "Names")
 PlaceCheckBox(cfgTab3, 0, 170, "TOPLEFT", "cBuffCD", "Countdowns")

 PlaceCheckBox(cfgTab3, 235, 100, "TOPLEFT", "cDebuffs", "Disable")
 PlaceCheckBox(cfgTab3, 235, 130, "TOPLEFT", "cDebuffBar", "Bars")
 PlaceCheckBox(cfgTab3, 235, 150, "TOPLEFT", "cDebuffName", "Names")
 PlaceCheckBox(cfgTab3, 235, 170, "TOPLEFT", "cDebuffCD", "Countdowns")
 PlaceCheckBox(cfgTab3, 235, 200, "TOPLEFT", "cPlayerDebuffs", "Player Debuffs Only")

 PlaceSlider(cfgTab3, 10, 250, "TOPLEFT", 200, "MaxBuffBars", "Max Buff Bars", 0, 12, suf.Auras.Buffs.Max, 8)
 PlaceSlider(cfgTab3, 245, 250, "TOPLEFT", 200, "MaxDebuffBars", "Max Debuff Bars", 0, 12, suf.Auras.Debuffs.Max, 8)

-- PlaceText(cfgTab3, 95, 270, "TOPLEFT", "MaxBuffBarsVal", "8", "MaxBuffBars")
-- PlaceText(cfgTab3, 325, 270, "TOPLEFT", "MaxDebuffBarsVal", "8", "MaxDebuffBars")

 -- Tab 4
 PlaceHeader(cfgTab4, 0, 10, "TOPLEFT", 450, "TargetAlphas", "Target Frame Transparency")

 PlaceCheckBox(cfgTab4, 0, 40, "TOPLEFT", "cRange", "Range Transparency")


 PlaceSlider(cfgTab4, 10, 90, "TOPLEFT", 200, "cInsideAlpha", "In Range Alpha %", 0, 100, suf.UI.OOCAlpha, 100)
 PlaceSlider(cfgTab4, 245, 90, "TOPLEFT", 200, "cOutsideAlpha", "Out of Range Alpha %", 0, 100, suf.UI.CombatAlpha, 55)

-- PlaceText(cfgTab4, 95, 110, "TOPLEFT", "cInsideAlphaVal", "100", "cInisideAlpha")
-- PlaceText(cfgTab4, 325, 110, "TOPLEFT", "cOutsideAlphaVal", "100", "cOutsideAlpha")


 PlaceHeader(cfgTab4, 0, 160, "TOPLEFT", 445, "PlayerAlphas", "Player Frame Transparency")

 PlaceSlider(cfgTab4, 10, 210, "TOPLEFT", 200, "cOOCAlpha", "Out of Combat Alpha %", 0, 100, suf.UI.OOCAlpha, 100)
 PlaceSlider(cfgTab4, 245, 210, "TOPLEFT", 200, "cCombatAlpha", "In Combat Alpha %", 0, 100, suf.UI.CombatAlpha, 100)

-- PlaceText(cfgTab4, 95, 230, "TOPLEFT", "cOOCAlphaVal", "100", "cOOCAlpha")
-- PlaceText(cfgTab4, 325, 230, "TOPLEFT", "cCombatAlphaVal", "100", "cCombatAlpha")


 
 PlaceCheckBox(cfgTab5, 0, 10, "TOPLEFT", "cComboPoints", "Enable Combo Points")
 
 PlaceSlider(cfgTab5, 0, 60, "TOP", 450, "comboHorzOffset", "Horizontal Position", -400, 400, cfg.ComboPoints.UI.OffsetX, 0)
 PlaceSlider(cfgTab5, 0, 140, "TOP", 450, "comboVertOffset", "Vertical Position", -500, 500, cfg.ComboPoints.UI.OffsetY, 0)

-- PlaceText(cfgTab5, 0, 85, "TOP", "comboHorzOffsetVal", "0", "comboHorzOffset")
-- PlaceText(cfgTab5, 0, 165, "TOP", "comboVertOffsetVal", "0", "comboVertOffset")
 
 PlaceColorPickerBox(cfgTab6, 0, 10, "TOPLEFT", "cFriendlyHealthColor", "Friendly Healthbar Color", {r=1, g=0, b=0.5, a=1}, "HealthFriendly")
 PlaceCheckBox(cfgTab6, 0, 0, "BOTTOMLEFT", "cHealthByClass", "Color Health By Class")

end

SkyUI.OnConfigLoaded = function ()
 if InCombatLockdown() then return true end
 local cfg = SkyUI.Config
 
 mnuitems.cHud:SetChecked(not suf.UI.Enabled)

 mnuitems.cFocus:SetChecked(suf.focus.Enabled)
 mnuitems.cPet:SetChecked(suf.playerpet.Enabled)
 mnuitems.cPetTarget:SetChecked(suf.playerpettarget.Enabled)
 mnuitems.cTargetTarget:SetChecked(suf.targettarget.Enabled)
 mnuitems.cTargetPet:SetChecked(suf.targetpet.Enabled)
 mnuitems.cTargetPetTarget:SetChecked(suf.targetpettarget.Enabled)

 mnuitems.HudScale:SetValue(suf.UI.Scale * 100)
 mnuitems.HudScaleVal:SetText(suf.UI.Scale * 100)

 mnuitems.HorzOffset:SetValue(suf.UI.OffsetX)
 mnuitems.HorzOffsetVal:SetText(suf.UI.OffsetX)

 mnuitems.VertOffset:SetValue(suf.UI.OffsetY)
 mnuitems.VertOffsetVal:SetText(suf.UI.OffsetY)



 mnuitems.cAuras:SetChecked(not suf.Auras.Enabled)
 mnuitems.cSwap:SetChecked(suf.Auras.Swap)
 mnuitems.cCDBD:SetChecked(not suf.Auras.CooldownBackdrop)
 

 mnuitems.cBuffs:SetChecked(not suf.Auras.Buffs.Enabled)
 mnuitems.cBuffBar:SetChecked(suf.Auras.Buffs.Bars)
 mnuitems.cBuffName:SetChecked(suf.Auras.Buffs.Names)
 mnuitems.cBuffCD:SetChecked(suf.Auras.Buffs.CD)

 mnuitems.cDebuffs:SetChecked(not suf.Auras.Debuffs.Enabled)
 mnuitems.cDebuffBar:SetChecked(suf.Auras.Debuffs.Bars)
 mnuitems.cDebuffName:SetChecked(suf.Auras.Debuffs.Names)
 mnuitems.cDebuffCD:SetChecked(suf.Auras.Debuffs.CD)
 mnuitems.cPlayerDebuffs:SetChecked(suf.Auras.Debuffs.PlayerOnly)

 
 
 
 mnuitems.MaxBuffBars:SetValue(suf.Auras.Buffs.Max)
 mnuitems.MaxBuffBarsVal:SetText(suf.Auras.Buffs.Max)

 mnuitems.MaxDebuffBars:SetValue(suf.Auras.Debuffs.Max)
 mnuitems.MaxDebuffBarsVal:SetText(suf.Auras.Debuffs.Max)


 mnuitems.cRange:SetChecked(suf.RangeTransparency)

 mnuitems.cOOCAlpha:SetValue(suf.UI.player.OOCAlpha * 100)
 mnuitems.cCombatAlpha:SetValue(suf.UI.player.CombatAlpha * 100)
 mnuitems.cOOCAlphaVal:SetText(suf.UI.player.OOCAlpha * 100)
 mnuitems.cCombatAlphaVal:SetText(suf.UI.player.CombatAlpha * 100)

 mnuitems.cInsideAlpha:SetValue(suf.UI.target.InsideAlpha * 100)
 mnuitems.cOutsideAlpha:SetValue(suf.UI.target.OutsideAlpha * 100)
 mnuitems.cInsideAlphaVal:SetText(suf.UI.target.InsideAlpha * 100)
 mnuitems.cOutsideAlphaVal:SetText(suf.UI.target.OutsideAlpha * 100)


 mnuitems.cHealthByClass:SetChecked(suf.ColorOptions.Health == sui.Structs.By.Class)
 
 
 mnuitems.cComboPoints:SetChecked(cfg.ComboPoints.UI.Enabled)
 
 mnuitems.comboHorzOffset:SetValue(cfg.ComboPoints.UI.OffsetX)
 mnuitems.comboHorzOffsetVal:SetText(cfg.ComboPoints.UI.OffsetX)

 mnuitems.comboVertOffset:SetValue(cfg.ComboPoints.UI.OffsetY)
 mnuitems.comboVertOffsetVal:SetText(cfg.ComboPoints.UI.OffsetY)
 
 mnuitems.cFriendlyHealthColor.clr = {r=suf.Clr["HealthFriendly"].r, g=suf.Clr["HealthFriendly"].g, b=suf.Clr["HealthFriendly"].b, a=1}
 mnuitems.cFriendlyHealthColor.clrTexture:SetColorTexture(suf.Clr["HealthFriendly"].r, suf.Clr["HealthFriendly"].g, suf.Clr["HealthFriendly"].b, 1)
 
 sui.Modules.Main:OnConfigUpdated()
end

SLASH_SKYUI1 = "/skyui"
SlashCmdList["SKYUI"] = function(msg, editBox) if SkyUIConfigMenu:IsVisible() then SkyUIConfigMenu:Hide() else SkyUIConfigMenu:Show() end end

SLASH_SKY1 = "/sky"
SlashCmdList["SKY"] = function(msg, editBox) if SkyUIConfigMenu:IsVisible() then SkyUIConfigMenu:Hide() else SkyUIConfigMenu:Show() end end











